package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.common.exception.DbException;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrConfirmationTermination;
import com.zksy.data.domain.response.XcrConfirmationTerminationResponse;
import com.zksy.data.mapper.XcrConfirmationTerminationMapper;
import com.zksy.data.service.XcrConfirmationTerminationService;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.support.TransactionTemplate;

import java.util.List;
import java.util.Vector;

/**
* @author 邵洋
* @description 针对表【xcr_confirmation_termination(非正常户认定解除信息表)】的数据库操作Service实现
* @createDate 2024-10-17 17:38:46
*/
@Service
@Slf4j
public class XcrConfirmationTerminationServiceImpl extends ServiceImpl<XcrConfirmationTerminationMapper, XcrConfirmationTermination>
    implements XcrConfirmationTerminationService{

    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Autowired
    private TransactionTemplate transactionTemplate;

    @Override
    @XhDataLogRecord("同步非正常户认定解除信息")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrConfirmationTermination> toDatabaseList = new Vector<>();
        creditCodes.parallelStream().forEach(creditCode -> {
            List<XcrConfirmationTermination> list = xhRequestUtil.httpRequestByUniCode(creditCode, address,
                    XcrConfirmationTerminationResponse.class,
                    XcrConfirmationTermination.class,
                    "SHXYDM"
            );
            if(list != null){
                toDatabaseList.addAll(list);
            }
        });
        transactionTemplate.execute((s)->{
            try {
                this.remove(null);
                this.saveBatch(toDatabaseList);
            } catch (Exception e) {
                s.setRollbackOnly();
                throw new DbException(e);
            }
            return null;
        });
        log.info("非正常户认定解除信息同步完成");
    }
}




